;**********************************************************************
;                                                                     *
;    Filename:	        ClonePI.asm                                   *
;    Date:              07.09.2005                                    *
;    File Version:      1.4                                           *
;                                                                     *
;    Author:		    Ը  (Andy_F)                       *
;    Company:                                                         *
;                                                                     * 
;**********************************************************************
;                                                                     *
;    Notes: PI    -          *
;                                                                     *
;    :                                                       *
;                                                                     *
;   v 1.4                                                             *
;     -     .       *
;     -   ""   .        *
;     -  ""               *
;            .                      *
;                                                                     *
;    v 1.3.1                                                          *
;      -     12  U1           *
;         ,        *
;          . .                      *
;      -                  *
;         ,   ,          *
;            " ". .        *
;                                                                     *
;    v 1.3                                                            *
;      -    ""                *
;         "".                                       *
;                                                                     *
;    v 1.2                                                            *
;      -      .         *
;                      *
;                    *
;        () .                *
;          3 .  ,             *
;                .     *
;            Up_min,        *
;               ,         *
;         D'105' -             *
;        10,5 .                                                  *
;                                                                     *
;    v 1.1                                                            *
;      -    3,            *
;        .      ,    *
;          1  2            *
;             ,          *
;              .   *
;      -          *
;          EEPROM.                                        *
;      - ,   ,          *
;            . , GuardInterval -          *
;        -  , DevFreq -   (     *
;            ), ADCFreq -        *
;        -    .                     *
;      -   ,  .                      *
;                                                                     *
;    v 1.0                                             *
;                                                                     *
;**********************************************************************

	list		p=16f873A				; list directive to define processor
	#include	<p16f873A.inc>			; processor specific variable definitions
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _HS_OSC & _WRT_OFF & _LVP_OFF & _CPD_OFF

	ERRORLEVEL -302						; supress message because of page change

;  Define Information
	#DEFINE	RS		PORTC, 4			; RC4 is RS line of LCD
	#DEFINE	E		PORTC, 5			; RC5 is E line of LCD
										; RB0-RB3 are D4-D7 of LCD
	#DEFINE	ADC_CS	PORTA, 3			; RA3 -  Chip Select  

;  Macro
EStrobe 	MACRO						;  Strobe the "E" Bit
	BSF	E
	BCF	E
 ENDM

;==================================================================================
; VARIABLE DEFINITIONS
w_temp			EQU		0x20			; variable used for context saving
w_temp1			EQU		0xA0			; reserve bank1 equivalent of w_temp 
status_temp		EQU		0x21			; variable used for context saving
pclath_temp		EQU		0x22			; variable used for context saving

DevFreq			EQU		D'10000000'		;   ( ).    . 
ADCFreq			EQU		D'1600000'		;      .
										;       . ,
										; MCP3201 - 1,6 MHz (D'1600000), ADS1286 - 200 KHz (D'200000').

OnInterval		EQU		D'100'			;     
StabilInterval	EQU		D'2'			;  "" 
IntegrInterval	EQU		D'15'			;  
Up_min 			EQU		D'105'			;   ,     
										; .    (D'105' - 10,5 ).    
										;        R33/R34.
										
;------ LCD Module commands --------
DISP_ON			EQU		0x00C			; Display on
CLR_DISP		EQU		0x001			; Clear the Display (    5 mS)
ENTRY_INC		EQU		0x006			;

LINE1           EQU     0x080           ;   
LINE2           EQU     0x0C0           ;   
CGRAM			EQU		0x048			; CGRAM (1- !!!  )

LCD_DATA        EQU     PORTB
;-----------------------------------

    cblock  0x30                               
TEMP
Temp
TempInt									;      

BUFFER									;       
BUFINT									;     

CntInt									;          
Cnt										;       
DCnt									;       
DCnt2									;       
DCntInt									;      
DCntInt2								;      
AutoSpeed								;  

huns
tens
ones

DataMin: 2
DataMax: 2

GuardInterval
x: 4
y: 2
RefLevel: 2
i

Upow									;   
Barrier									;  
Volume									;  

SData:	0, SDataHH, SDataHL, SDataLH			;     
SGnd: 	0, SGndHH, SGndHL, SGndLH, SGndLL		;       ( )
Delta: 	0, DeltaHH, DeltaHL, DeltaLH, DeltaLL	;   ( )
ADCRes: 0, ADCResH, ADCResL						;    
Resp: 	0, RespH, RespL
TmpResp: 0, TRespH, TRespL
SResp:	0, SRespHH, SRespHL, SRespLH			; "" 
    endc
;==================================================================================

;**********************************************************************
	ORG     0x000				; processor reset vector
  	GOTO    main				; go to beginning of program

;*********************   **************************
	ORG     0x004             	; interrupt vector location

	MOVWF   w_temp            	; save off current W register contents
	MOVFW	STATUS          	; move status register into W register
	BCF     STATUS, RP0        	; ensure file register bank set to 0
	MOVWF	status_temp       	; save off contents of STATUS register
	MOVFW	PCLATH		  		; move pclath register into w register
	MOVWF	pclath_temp	  		; save off contents of PCLATH register

	BTFSC	INTCON, RBIF		;      B,...
	GOTO	PORTB_INT			; ...     

	BCF		PORTC, 0			;     400  7
	BCF		PORTA, 5			;  "0"   RA5 ( IRF740)

	MOVLW	OnInterval
	MOVWF	CntInt
zar_loop:
	DECFSZ	CntInt, f			;     = 1.2 uS
	GOTO	zar_loop

	BSF		PORTA, 5			;  "1"   RA5 ( IRF740)
	
	MOVFW	GuardInterval
	MOVWF	CntInt				
guard_loop:
	DECFSZ	CntInt, f			;     = 1.2 uS
	GOTO	guard_loop

	BSF		PORTC, 0			;     7  400
	
	MOVLW	StabilInterval
	MOVWF	CntInt				
comfort_loop:
	DECFSZ	CntInt, f			;     = 1.2 uS
	GOTO	comfort_loop

	BSF		PORTC, 3			;    
	BCF		PORTC, 2			;     

	MOVLW	IntegrInterval
	MOVWF	CntInt
integ_loop:
	DECFSZ	CntInt, f			;     = 1.2 uS
	GOTO	integ_loop
	
	BSF		PORTC, 2			;     
	
;---------     ---------
	CALL	ADC_WORK			;   

	MOVFW	RCREG				;  1   
	MOVWF	BUFINT				;     ...
	CALL	reverse8bit			;  
	MOVWF	ADCResH				;    
            
	MOVFW	RCREG				;  2   
	MOVWF	BUFINT				;     ...
	CALL	reverse8bit			;  
	MOVWF	ADCResL				;    

	RRF		ADCResH, f			;     1  
	RRF		ADCResL, f			;     1    
	MOVLW	0x0F				;    4-    
	ANDWF	ADCResH, f			;      
;----------------------------------------

	BCF		PORTC, 3			;    

;--      --
	MOVFW	ADCResH				
	MOVWF	DeltaHH
	MOVFW	ADCResL	    
	MOVWF	DeltaHL
;----------------------------------------------------

;-- 16-bit Subtraction-with-Borrow --
    MOVFW	SDataHL				;   16            
    SUBWF   DeltaHL, f
    MOVFW	SDataHH
    SKPC
    INCFSZ  SDataHH, w
    SUBWF   DeltaHH, f           
;------------------------------------

	CLRC						;    (  ).
	CLRF	DeltaLH				;   

;---    4 (  16)   ---
    MOVLW   .4
    MOVWF   CntInt         		;     
loop_D1:
    BTFSC   DeltaHH, 7    		;  DeltaHH -    - 
    SETC                		;    -       
    RRF     DeltaHH, f    		;    3 ...
    RRF     DeltaHL, f    		; ...  Delta ...
    RRF     DeltaLH, f  		; ...   .       (..   )
    DECFSZ  CntInt, f      		;        0
    GOTO    loop_D1
;----------------------------------------------------

;--     --
    MOVFW   DeltaHH       		;    
    ADDWF   SDataHH, f    		;  
    MOVFW   DeltaHL       		;   
    ADDWF   SDataHL, f
    SKPNC               		;         -   
    INCF    SDataHH, f    		;    "1"   
    MOVFW   DeltaLH     		;  ""  
    ADDWF   SDataLH, f
    BNC     end_sum_d   		;       
    INCF    SDataHL, f    		;   -     
    SKPNZ               		;      0 -   
    INCF    SDataHH, f    		;      
end_sum_d
;---------------------------------------------

;--      --
	MOVFW	ADCResH				
	MOVWF	DeltaHH
	MOVFW	ADCResL	    
	MOVWF	DeltaHL
;----------------------------------------------------

;-- 16-bit Subtraction-with-Borrow --
    MOVFW	SGndHL				;   16            
    SUBWF   DeltaHL, f
    MOVFW	SGndHH
    SKPC
    INCFSZ  SGndHH, w
    SUBWF   DeltaHH, f           
;------------------------------------

	CLRC						;    (  ).
	CLRF	DeltaLH				;   
	CLRF	DeltaLL

;---        ( "") ---

    MOVFW   AutoSpeed			;   
    MOVWF   CntInt         		;     
loop_D2:
    BTFSC   DeltaHH, 7    		;  DeltaHH -    - 
    SETC                		;    -       
    RRF     DeltaHH, f    		;    4 ...
    RRF     DeltaHL, f    		; ...  Delta ...
    RRF     DeltaLH, f  		; ...   .       (..   )
    RRF     DeltaLL, f  		; ...   .       (..   )
    DECFSZ  CntInt, f      		;        0
    GOTO    loop_D2
;----------------------------------------------------------------------------

;--    " " --
    MOVFW   DeltaHH       		;    
    ADDWF   SGndHH, f    		;  
    MOVFW   DeltaHL       		;   
    ADDWF   SGndHL, f
    SKPNC               		;         -   
    INCF    SGndHH, f    		;    "1"   
    MOVFW   DeltaLH     		;  ""  
    ADDWF   SGndLH, f
    BNC		sum_ll          	;         -   
    INCF    SGndHL, f    		;    "1"   
    SKPNZ						;    0 -   
    INCF	SGndHH, f
sum_ll:    
	MOVFW	DeltaLL
	ADDWF	SGndLL, f    
    BNC     end_sum_gnd   		;       
	INCF	SGndLH, f		
	BNZ		end_sum_gnd
    INCF    SGndHL, f    		;   -     
    SKPNZ               		;      0 -   
    INCF    SGndHH, f    		;      
end_sum_gnd
;-----------------------------------------------------
	GOTO	END_INT
	
PORTB_INT:
	MOVFW	PORTB
	BTFSS	PORTB, 4			;   "0" !!!!
	GOTO	RB4_INT
	BTFSS	PORTB, 5
	GOTO	RB5_INT
	BTFSS	PORTB, 6
	GOTO	RB6_INT
	BTFSS	PORTB, 7
	GOTO	RB7_INT
	GOTO	END_INT
	
RB4_INT:						;  On/Off (RA2)
	BTFSS	PORTA, 2
	GOTO	light_is_off
	BCF		PORTA, 2
	GOTO	KeyRelease
light_is_off:	
	BSF		PORTA, 2
	GOTO	KeyRelease

RB5_INT:						;  "0"
	MOVFW	SDataLH
	MOVWF	SGndLH
	MOVFW	SDataHL
	MOVWF	SGndHL
	MOVFW	SDataHH
	MOVWF	SGndHH
	CLRF	SGndLL
	GOTO	KeyRelease

RB6_INT:						;  
	INCF	Volume, f
	BTFSC	Volume, 3			;  "0"  "7"
	CLRF	Volume
;--     EEPROM --
	BSF		STATUS, RP1
	BSF		STATUS, RP0			;  3
	BTFSC 	EECON1, WR			; Wait for write...
	GOTO 	$-1 				; ...to complete
	BCF 	STATUS, RP0 		; Bank 2
	CLRF	EEADR				;   EEPROM
	BCF		STATUS, RP1			;  0
	MOVFW   Volume				;   
	BSF		STATUS, RP1			;  2
	MOVWF   EEDATA				;     EEPROM
	BSF		STATUS, RP0 		; Bank 3
	BCF		EECON1, EEPGD 		; Point to DATA memory
	;       EEPROM
	BSF		EECON1, WREN		;  
	MOVLW	0x55
	MOVWF   EECON2
	MOVLW	0xAA
	MOVWF	EECON2
	BSF		EECON1, WR
	BCF		EECON1, WREN    	;      
	BCF		STATUS, RP1
	BCF		STATUS, RP0			;  0
;--------------------------------------------
	GOTO	KeyRelease
	
RB7_INT:						;  
	INCF	Barrier, f
	BTFSS	Barrier, 4			;  "1"  "15"
	GOTO	end_barr
	MOVLW	.1					;     16,    1.
	MOVWF	Barrier
end_barr:
;--     EEPROM --
	BSF		STATUS, RP1
	BSF		STATUS, RP0			;  3
	BTFSC 	EECON1, WR			; Wait for write...
	GOTO 	$-1 				; ...to complete
	BCF 	STATUS, RP0 		; Bank 2
	MOVLW	.1
	MOVWF	EEADR				;   EEPROM
	BCF		STATUS, RP1			;  0
	MOVFW   Barrier				;   
	BSF		STATUS, RP1			;  2
	MOVWF   EEDATA				;     EEPROM
	BSF		STATUS, RP0 		; Bank 3
	BCF		EECON1, EEPGD 		; Point to DATA memory
	;       EEPROM
	BSF		EECON1, WREN		;  
	MOVLW	0x55
	MOVWF   EECON2
	MOVLW	0xAA
	MOVWF	EECON2
	BSF		EECON1, WR
	BCF		EECON1, WREN    	;      
	BCF		STATUS, RP1
	BCF		STATUS, RP0			;  0
;-----------------------------------------
	GOTO	KeyRelease

; ---- ,      ----
KeyRelease:	
;--    --------
	MOVLW	0x3F				;     (256)
	MOVWF   DCntInt2			; ...  (16)
DLOut2:	
	MOVLW   0xFF            	;    ...
	MOVWF   DCntInt          	; ...  (256)
DLIn2:							;    ~0,3 mS
	DECFSZ  DCntInt, f       	;   
	GOTO    DLIn2	        	;  DCnt  0,  
	DECFSZ  DCntInt2, f			;     
	GOTO    DLOut2          	;  DCnt2  0,  
;--     --

	COMF	PORTB, w			;    B  
	ANDLW	b'11110000'			;   
	SKPZ
	GOTO	KeyRelease	
; ---------------------------------------------------

END_INT:
	BCF		PIR1, CCP1IF		;      CCP1
	BCF		INTCON, RBIF		;     

	BCF		STATUS, RP0        	; ensure file register bank set to 0
	MOVFW	pclath_temp		  	; retrieve copy of PCLATH register
	MOVWF	PCLATH		  		; restore pre-isr PCLATH register contents
	MOVFW	status_temp     	; retrieve copy of STATUS register
	MOVWF	STATUS            	; restore pre-isr STATUS register contents
	SWAPF	w_temp, f
	SWAPF	w_temp, w          	; restore pre-isr W register contents
	RETFIE                    	; return from interrupt

;************************    *************************

main
    CLRF    STATUS          	; Do initialization (Bank 0)
    CLRF    INTCON          	;   
	CLRF    PIR1            	;   -  
	CLRF    PIR2

    MOVLW   b'00101000'
    MOVWF   PORTA           	;     (RA5)=1  _S  (RA3)=1 ( )
    CLRF    PORTB           	;    B   0...
    MOVLW	b'00000100'
    MOVWF   PORTC           	;    C   0,  RC2 -     
    
    BSF     STATUS, RP0     	; Select Bank 1

    MOVLW   b'11010011'
    MOVWF   TRISA           	;      (RA5),  (RA3)   (RA2)
    
    MOVLW   b'11110000'
    MOVWF   TRISB           	;    B -    RB4

	MOVLW	b'11000000'
	MOVWF	TRISC				;    C   ,  USART

    BCF     OPTION_REG,NOT_RBPU	;     B   

    BCF     STATUS, RP0     	; Select Bank 0
    
;--    --
	CLRF	SDataHH
	CLRF	SDataHL
	CLRF	SDataLH			
	CLRF	SGndHH
	CLRF	SGndHL
	CLRF	SGndLH
	CLRF	SGndLL
	CLRF	SResp
	CLRF	SResp+1
	CLRF	SResp+2
;----------------------------------

	CALL	InitLCD				;  LCD

  	MOVLW   LINE1+4        		;   5-      
   	CALL    SendINS        
	MOVLW	'C'
	CALL	SendCHAR
	MOVLW	'l'
	CALL	SendCHAR
	MOVLW	'o'
	CALL	SendCHAR
	MOVLW	'n'
	CALL	SendCHAR
	MOVLW	'e'
	CALL	SendCHAR
	MOVLW	' '
	CALL	SendCHAR
	MOVLW	'P'
	CALL	SendCHAR
	MOVLW	'I'
	CALL	SendCHAR
  	MOVLW   LINE2+4        		;   5-      
   	CALL    SendINS        
	MOVLW	'v'
	CALL	SendCHAR
	MOVLW	'e'
	CALL	SendCHAR
	MOVLW	'r'
	CALL	SendCHAR
	MOVLW	'.'
	CALL	SendCHAR
	MOVLW	' '
	CALL	SendCHAR
	MOVLW	'1'
	CALL	SendCHAR
	MOVLW	'.'
	CALL	SendCHAR
	MOVLW	'4'
	CALL	SendCHAR

    MOVLW	.8
    MOVWF	AutoSpeed			;     

;--     EEPROM --
	BSF		STATUS, RP1			;
	BCF		STATUS, RP0			; Bank 2
	CLRF	EEADR				; Address to read
	BSF		STATUS, RP0			; Bank 3
	BCF		EECON1,	EEPGD		; Point to Data memory
	BSF 	EECON1, RD			; EE Read
	BCF		STATUS, RP0			; Bank 2
	MOVFW	EEDATA				; W = EEDATA
	BCF		STATUS, RP1			;  0
	MOVWF	Volume
	SUBLW	.7
	BC		end_read_vol
	MOVLW	.5
	MOVWF	Volume				;    
end_read_vol:
;---------------------------------------------

;--     EEPROM --
	BSF		STATUS, RP1			;
	BCF		STATUS, RP0			; Bank 2
	MOVLW 	.1					; 
	MOVWF	EEADR				; Address to read
	BSF		STATUS, RP0			; Bank 3
	BCF		EECON1,	EEPGD		; Point to Data memory
	BSF 	EECON1, RD			; EE Read
	BCF		STATUS, RP0			; Bank 2
	MOVFW	EEDATA				; W = EEDATA
	BCF		STATUS, RP1			;  0
	MOVWF	Barrier
	SUBLW	.15
	BNC		barr_default
	TSTF	Barrier
	BNZ		end_read_barr
barr_default:
    MOVLW	.4
    MOVWF	Barrier				;    
end_read_barr:
;------------------------------------------
	CALL	Delay80ms			;    SData 
	CALL	Delay80ms			;    SData 
	CALL	Delay80ms			;    SData 
	CALL	Delay80ms			;    SData 
	CALL	Delay80ms			;    SData 
	CALL	Delay80ms			;    SData 
	CALL	Delay80ms			;    SData 
	CALL	Delay80ms			;    SData

	MOVLW	CLR_DISP			; Clear the Display RAM
	CALL	SendINS
	CALL	Delay5ms			; Wait 5 msecs (Note, Can take up to 4.1 msecs)

  	MOVLW   LINE1+5        		;   5-      
   	CALL    SendINS        
	MOVLW	'T'
	CALL	SendCHAR
	MOVLW	'u'
	CALL	SendCHAR
	MOVLW	'n'
	CALL	SendCHAR
	MOVLW	'e'
	CALL	SendCHAR
	MOVLW	'.'
	CALL	SendCHAR
	MOVLW	'.'
	CALL	SendCHAR
	MOVLW	'.'
	CALL	SendCHAR

;=======     =========

	MOVLW	.1					;    
	MOVWF	GuardInterval	
	
    CALL 	INIT_USART      	;    ( )
	BSF		INTCON, RBIE		;      RB4-RB7

	CALL	InitCCP1			;  CCP1   
	CALL	InitCCP2			;  CCP2   
	CALL	InitADC				;   

	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData

	MOVFW	SDataHH				;     ,  1
	MOVWF	DataMin
	MOVFW	SDataHL
	MOVWF	DataMin+1

	MOVLW	.60				;    
	MOVWF	GuardInterval

	CALL	Delay80ms			;    SData (?)
	CALL	Delay80ms			;    SData (?)
	CALL	Delay80ms			;    SData (?)
	CALL	Delay80ms			;    SData

	MOVFW	SDataHH				;     ,  100
	MOVWF	DataMax
	MOVFW	SDataHL
	MOVWF	DataMax+1

;-- ;       --
    MOVFW   DataMin+1				
    SUBWF   DataMax+1, w
    MOVWF	RefLevel
    MOVFW	DataMin
    SKPC
    INCFSZ  DataMin, w
    SUBWF   DataMax, w
    MOVWF	RefLevel           
;---------------------------------------------------------------
;---   3 ---
	MOVFW	RefLevel				
	MOVWF	x+1
	MOVFW	RefLevel+1
	MOVWF	x
	MOVLW	.3
	MOVWF	y
	CLRF	y+1
	CALL	div16by16
;-------------------
;--    --
    MOVFW   x				
    SUBWF   DataMax+1, w
    MOVWF	RefLevel
    MOVFW	x+1
    SKPC
    INCFSZ  x+1, w
    SUBWF   DataMax, w
    MOVWF	RefLevel           
;----------------------------------

	MOVLW	.40
	MOVWF	i	
	MOVLW	0x1F
	MOVWF	x					;   
	MOVLW	0xFF
	MOVWF	x+1

loop_tune:
	MOVFW	i
	MOVWF	GuardInterval
	MOVWF	BUFFER
	CALL	BINToBCD
	MOVLW	LINE2+7
	CALL	SendINS
	MOVFW	tens
	CALL	SendCHAR
	MOVFW	ones
	CALL	SendCHAR	
	
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	
	MOVFW	SDataHH
	MOVWF	DataMax
	MOVFW	SDataHL
	MOVWF	DataMax+1
	
;--        --
    MOVFW   RefLevel+1				
    SUBWF   DataMax+1, f
    MOVFW	RefLevel
    SKPC
    INCFSZ  RefLevel, w
    SUBWF   DataMax, f           
;---------------------------------------------------------
	
	BC		next_GI
	GOTO	final_tune	
	
next_GI:
	MOVFW	DataMax
	MOVWF	x
	MOVFW	DataMax+1
	MOVWF	x+1
	DECF	i, f
	GOTO	loop_tune
	
final_tune:
	BTFSS	DataMax, 7
	GOTO	pos_DM
	COMF	DataMax, f
	NEGF	DataMax+1, f
	SKPNZ
	INCF	DataMax, f
pos_DM:
	
	BTFSS	x, 7
	GOTO	pos_x
	COMF	x, f
	NEGF	x+1, f
	SKPNZ
	INCF	x, f
pos_x:
	
;--        --
    MOVFW   DataMax+1				
    SUBWF   x+1, f
    MOVFW	DataMax
    SKPC
    INCFSZ  DataMax, w
    SUBWF   x, f           
;---------------------------------------------------------
	
	SKPC
	INCF	GuardInterval, f
;================================================================
		
	MOVFW	GuardInterval
	MOVWF	BUFFER
	CALL	BINToBCD
	
  	MOVLW   LINE2+7        		;   5-      
   	CALL    SendINS        
	MOVFW	tens
	CALL	SendCHAR
	MOVFW	ones
	CALL	SendCHAR
	
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData
	CALL	Delay80ms			;    SData

;--------   ----------
	BSF		STATUS, RP0			;    1
	MOVLW	0x9B
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0	
	MOVLW	0x4E
	MOVWF	CCPR2L				;     
	BSF		T2CON, TMR2ON
	CALL	Delay80ms			
	BCF		T2CON, TMR2ON

	CALL	Delay80ms			
	BSF		STATUS, RP0			;    1
	MOVLW	0x64
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0	
	MOVLW	0x32
	MOVWF	CCPR2L				;     
	BSF		T2CON, TMR2ON
	CALL	Delay80ms			
	BCF		T2CON, TMR2ON

	CALL	Delay80ms			
	BSF		STATUS, RP0			;    1
	MOVLW	0x46
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0	
	MOVLW	0x23
	MOVWF	CCPR2L				;     
	BSF		T2CON, TMR2ON
	CALL	Delay80ms			
	BCF		T2CON, TMR2ON

	CLRF	CCP2CON				;      "0"
	MOVLW	0x0C			
	MOVWF	CCP2CON				;   CCP2/PWM2   .	 

	CALL	Delay80ms			
	CALL	Delay80ms			
;-------------------------------------------

	MOVFW	SDataHH				;   ...
	MOVWF	SGndHH				; ... ""   ""
	MOVFW	SDataHL			
	MOVWF	SGndHL			

	MOVLW	CLR_DISP			; Clear the Display RAM
	CALL	SendINS
	CALL	Delay5ms			; Wait 5 msecs (Note, Can take up to 4.1 msecs)

loop:
;---------------------    -------------------
	BSF		ADCON0, GO			;    
ADCInLoop:
	BTFSC	ADCON0, GO			;      
	GOTO	ADCInLoop
	MOVFW	ADRESH
	MOVWF	Upow
;----------------------------------------------------------------------

;------ ,     -------
	MOVLW	Up_min
	SUBWF	Upow, w
	SKPC		
	CALL	pow_low
;----------------------------------------------
   
;----   ------
	MOVFW	SGndHL
	MOVWF	RespL
	MOVFW	SGndHH
	MOVWF	RespH

    MOVFW   SDataHL				;   16            
    SUBWF   RespL, f
    MOVFW	SDataHH
    SKPC
    INCFSZ  SDataHH, w
    SUBWF   RespH, f           
;----------------------------

;*********************    **********************
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL

	MOVFW	Barrier				;   !!!
	SUBWF	TRespL, f			;    
	SKPC
	DECF	TRespH, f
	
	MOVLW	LINE2+.8
	CALL	SendINS

	BTFSS	TRespH, 7		
	GOTO	positive
	BCF		T2CON, TMR2ON		;     TMR2 ( )

	CLRF	CCP2CON				;      "0"
	MOVLW	0x0C			
	MOVWF	CCP2CON				;   CCP2/PWM2   .	 

	MOVLW	.8
	MOVWF	AutoSpeed			;       
	MOVLW	' '
	CALL	SendCHAR
	GOTO	end_sa

positive:	

;--     -- 
	MOVFW	Volume
	SUBLW	.1
	BZ		sound_const
	MOVFW	Volume
	SUBLW	.2
	BZ		sound_const

	TSTF	RespH				; ,   -    
	BNZ		HI_Resp
	MOVFW	RespL
	MOVWF	TRespL				;   ( )   
	SUBLW	.63					;       0..63
	BNC		MidRange			; ...   -    ...
	CLRC
	RLF		TRespL, w			; ...  ,    2 (   )
	GOTO	end_resp_range
MidRange:
	MOVFW	RespL
	SUBLW	.127				;       64..127
	BNC		HiRange				; ...   -      ...
	MOVLW	.64					; ...   -  64 (  )
	ADDWF	TRespL, w
	GOTO	end_resp_range
HiRange:	
	CLRC
	RRF		TRespL, f			;   128..255   8 ...
	CLRC
	RRF		TRespL, f
	CLRC
	RRF		TRespL, w
	ADDLW	.191				; ...   191
	GOTO	end_resp_range

sound_const:
	MOVLW	.0
	
end_resp_range:

	SUBLW	0xFF

	BSF		STATUS, RP0			;    1
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0	
	GOTO	end_change_fsound
HI_Resp:	
	MOVFW	RespH
	SUBLW	0x2F
	BSF		STATUS, RP0			;    1
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0	
end_change_fsound:
;---------------------------------------------
;--   --
	MOVWF	TRespH				;       
	MOVFW	Volume
	SUBLW	.8	
	MOVWF	Cnt					;  -    
	CLRC
	CLRF	TRespL				;     
loop_vol:
	RRF		TRespH, f
	RRF		TRespL, f			;       
	CLRC
	DECFSZ	Cnt, f
	GOTO	loop_vol
end_lv:	

	MOVFW	TRespL
	ANDLW	b'11000000'			;       
	MOVWF	TRespL
	RRF		TRespL, f
	RRF		TRespL, f			;        CCP1CON 
	
	MOVFW	CCP1CON
	ANDLW	b'11001111'			;      
	IORWF	TRespL, w			;    CCP1CON    TRespL
	MOVWF	CCP1CON				;     
	MOVFW	TRespH
	MOVWF	CCPR2L				;     
;-------------------------

	BTFSS	T2CON, TMR2ON		;        
	BSF		T2CON, TMR2ON

	MOVLW	.13					;      
	MOVWF	AutoSpeed
	MOVLW	'S'
	CALL	SendCHAR
end_sa:
;*************************************************************

	MOVFW	RespH				;   ...
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL

;-----    -------	
	BTFSS	TRespH, 7			;     	
	GOTO	end_mod
	COMF	TRespH, f			;   
	NEGF	TRespL, f			;   
	SKPNZ						;   Z ...
	INCF	TRespH, f			; ...       
end_mod;						;    

;------        ------
	MOVFW	Barrier				;   !!!
	SUBWF	TRespL, f			;      
	SKPC
	DECF	TRespH, f

	MOVLW	LINE2+.7
	CALL	SendINS

	BTFSS	TRespH, 7		
	GOTO	positive2
	MOVLW	' '
	CALL	SendCHAR
	GOTO	end_sa2
positive2:						;      
	MOVLW	'A'
	CALL	SendCHAR
end_sa2:


;====   () ====
;--     
	MOVFW	RespH				
	MOVWF	DeltaHH
	MOVFW	RespL	    
	MOVWF	DeltaHL
;--
;-- 16-bit Subtraction-with-Borrow
    MOVFW	SRespHL				;   16            
    SUBWF   DeltaHL, f
    MOVFW	SRespHH
    SKPC
    INCFSZ  SRespHH, w
    SUBWF   DeltaHH, f           
;--
	CLRC						;    (  ).
	CLRF	DeltaLH				;   

	BTFSC	DeltaHH, 7			; ,   
	GOTO	smooth

	MOVFW	RespH
	MOVWF	SRespHH
	MOVFW	RespL
	MOVWF	SRespHL
	CLRF	SRespLH
	GOTO	end_smooth

smooth:
;---    5 (  32)   ---
    MOVLW   .5
    MOVWF   Cnt         		;     
loop_DR:
    BTFSC   DeltaHH, 7    		;  DeltaHH -    - 
    SETC                		;    -       
    RRF     DeltaHH, f    		;    3 ...
    RRF     DeltaHL, f    		; ...  Delta ...
    RRF     DeltaLH, f  		; ...   .       (..   )
    DECFSZ  Cnt, f      		;        0
    GOTO    loop_DR
;----------------------------------------------------
;---     ---

    MOVFW   DeltaHH       		;    
    ADDWF   SRespHH, f    		;  
    MOVFW   DeltaHL       		;   
    ADDWF   SRespHL, f
    SKPNC               		;         -   
    INCF    SRespHH, f    		;    "1"   
    MOVFW   DeltaLH     		;  ""  
    ADDWF   SRespLH, f
    BNC     end_sum_DR   		;       
    INCF    SRespHL, f    		;   -     
    SKPNZ               		;      0 -   
    INCF    SRespHH, f    		;      
end_sum_DR:
;----------------------------------------------

	BTFSS	SRespHH, 7			;   ...
	GOTO	end_smooth
	CLRF	SRespLH
	CLRF	SRespHL
	CLRF	SRespHH
	
end_smooth:
;======================================

;=====    =====

	BTFSS	RespH, 7		 
	GOTO	positive3
	CLRF	RespH				;    -  "0"
	CLRF	RespL

positive3:
  	MOVLW   LINE1				;                
   	CALL    SendINS        

;----  0 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
	TSTF	TRespH
	BNZ		_lcd0_on
	TSTF	TRespL
	BNZ		_lcd0_on
	GOTO	_lcd0_off
_lcd0_on:
    MOVLW	.7
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd0_1
	MOVLW	0x03
	GOTO	_end_lcd0
_lcd0_1:
	MOVLW	0x01
	GOTO	_end_lcd0
_lcd0_off:
    MOVLW	.7
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd0_
	MOVLW	0x02
	GOTO	_end_lcd0
_lcd0_:
	MOVLW	' '
	GOTO	_end_lcd0
_end_lcd0:
	CALL	SendCHAR
;-------------------
;----  1 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.7
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd1_on
	GOTO	_lcd1_off
_lcd1_on:
    MOVLW	.15
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd1_1
	MOVLW	0x03
	GOTO	_end_lcd1
_lcd1_1:
	MOVLW	0x01
	GOTO	_end_lcd1
_lcd1_off:
    MOVLW	.15
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd1_
    MOVLW	.7
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd1_
	MOVLW	0x02
	GOTO	_end_lcd1
_lcd1_:
	MOVLW	' '
_end_lcd1:
	CALL	SendCHAR
;-------------------
;----  2 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.15
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd2_on
	GOTO	_lcd2_off
_lcd2_on:
    MOVLW	.23
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd2_1
	MOVLW	0x03
	GOTO	_end_lcd2
_lcd2_1:
	MOVLW	0x01
	GOTO	_end_lcd2
_lcd2_off:
    MOVLW	.23
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd2_
    MOVLW	.15
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd2_
	MOVLW	0x02
	GOTO	_end_lcd2
_lcd2_:
	MOVLW	' '
_end_lcd2:
	CALL	SendCHAR
;-------------------
;----  3 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.23
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd3_on
	GOTO	_lcd3_off
_lcd3_on:
    MOVLW	.31
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd3_1
	MOVLW	0x03
	GOTO	_end_lcd3
_lcd3_1:
	MOVLW	0x01
	GOTO	_end_lcd3
_lcd3_off:
    MOVLW	.31
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd3_
    MOVLW	.23
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd3_
	MOVLW	0x02
	GOTO	_end_lcd3
_lcd3_:
	MOVLW	' '
_end_lcd3:
	CALL	SendCHAR
;-------------------
;----  4 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.31
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd4_on
	GOTO	_lcd4_off
_lcd4_on:
    MOVLW	.47
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd4_1
	MOVLW	0x03
	GOTO	_end_lcd4
_lcd4_1:
	MOVLW	0x01
	GOTO	_end_lcd4
_lcd4_off:
    MOVLW	.47
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd4_
    MOVLW	.31
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd4_
	MOVLW	0x02
	GOTO	_end_lcd4
_lcd4_:
	MOVLW	' '
_end_lcd4:
	CALL	SendCHAR
;-------------------
;----  5 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.47
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd5_on
	GOTO	_lcd5_off
_lcd5_on:
    MOVLW	.63
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd5_1
	MOVLW	0x03
	GOTO	_end_lcd5
_lcd5_1:
	MOVLW	0x01
	GOTO	_end_lcd5
_lcd5_off:
    MOVLW	.63
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd5_
    MOVLW	.47
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd5_
	MOVLW	0x02
	GOTO	_end_lcd5
_lcd5_:
	MOVLW	' '
_end_lcd5:
	CALL	SendCHAR
;-------------------
;----  6 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.63
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd6_on
	GOTO	_lcd6_off
_lcd6_on:
    MOVLW	.95
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd6_1
	MOVLW	0x03
	GOTO	_end_lcd6
_lcd6_1:
	MOVLW	0x01
	GOTO	_end_lcd6
_lcd6_off:
    MOVLW	.95
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd6_
    MOVLW	.63
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd6_
	MOVLW	0x02
	GOTO	_end_lcd6
_lcd6_:
	MOVLW	' '
_end_lcd6:
	CALL	SendCHAR
;-------------------
;----  7 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.95
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd7_on
	GOTO	_lcd7_off
_lcd7_on:
    MOVLW	.127
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd7_1
	MOVLW	0x03
	GOTO	_end_lcd7
_lcd7_1:
	MOVLW	0x01
	GOTO	_end_lcd7
_lcd7_off:
    MOVLW	.127
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd7_
    MOVLW	.95
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd7_
	MOVLW	0x02
	GOTO	_end_lcd7
_lcd7_:
	MOVLW	' '
_end_lcd7:
	CALL	SendCHAR
;-------------------
;----  8 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.127
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd8_on
	GOTO	_lcd8_off
_lcd8_on:
    MOVLW	.191
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd8_1
	MOVLW	0x03
	GOTO	_end_lcd8
_lcd8_1:
	MOVLW	0x01
	GOTO	_end_lcd8
_lcd8_off:
    MOVLW	.191
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd8_
    MOVLW	.127
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd8_
	MOVLW	0x02
	GOTO	_end_lcd8
_lcd8_:
	MOVLW	' '
_end_lcd8:
	CALL	SendCHAR
;-------------------
;----  9 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	.191
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd9_on
	GOTO	_lcd9_off
_lcd9_on:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC		_lcd9_1
	MOVLW	0x03
	GOTO	_end_lcd9
_lcd9_1:
	MOVLW	0x01
	GOTO	_end_lcd9
_lcd9_off:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BC	_lcd9_
    MOVLW	.191
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd9_
	MOVLW	0x02
	GOTO	_end_lcd9
_lcd9_:
	MOVLW	' '
_end_lcd9:
	CALL	SendCHAR
;-------------------
;----  10 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	0xFF
    SUBWF   TRespL, f
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   TRespH, f      
	BC		_lcd10_on
	GOTO	_lcd10_off
_lcd10_on:
    MOVLW	0x7F
    SUBWF   SRespHL, w
    MOVLW	.1
    SKPC
    MOVLW	.2
    SUBWF   SRespHH, w      
	BC		_lcd10_1
	MOVLW	0x03
	GOTO	_end_lcd10
_lcd10_1:
	MOVLW	0x01
	GOTO	_end_lcd10
_lcd10_off:
    MOVLW	0x7F
    SUBWF   SRespHL, w
    MOVLW	.1
    SKPC
    MOVLW	.2
    SUBWF   SRespHH, w      
	BC	_lcd10_
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.0
    SKPC
    MOVLW	.1
    SUBWF   SRespHH, w      
	BNC	    _lcd10_
	MOVLW	0x02
	GOTO	_end_lcd10
_lcd10_:
	MOVLW	' '
_end_lcd10:
	CALL	SendCHAR
;--------------------
;----  11 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	0x7F
    SUBWF   TRespL, f
    MOVLW	.1
    SKPC
    MOVLW	.2
    SUBWF   TRespH, f      
	BC		_lcd11_on
	GOTO	_lcd11_off
_lcd11_on:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.1
    SKPC
    MOVLW	.2
    SUBWF   SRespHH, w      
	BC		_lcd11_1
	MOVLW	0x03
	GOTO	_end_lcd11
_lcd11_1:
	MOVLW	0x01
	GOTO	_end_lcd11
_lcd11_off:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.1
    SKPC
    MOVLW	.2
    SUBWF   SRespHH, w      
	BC	_lcd11_
    MOVLW	0x7F
    SUBWF   SRespHL, w
    MOVLW	.1
    SKPC
    MOVLW	.2
    SUBWF   SRespHH, w      
	BNC	    _lcd11_
	MOVLW	0x02
	GOTO	_end_lcd11
_lcd11_:
	MOVLW	' '
_end_lcd11:
	CALL	SendCHAR
;--------------------
;----  12 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	0xFF
    SUBWF   TRespL, f
    MOVLW	.1
    SKPC
    MOVLW	.2
    SUBWF   TRespH, f      
	BC		_lcd12_on
	GOTO	_lcd12_off
_lcd12_on:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.2
    SKPC
    MOVLW	.3
    SUBWF   SRespHH, w      
	BC		_lcd12_1
	MOVLW	0x03
	GOTO	_end_lcd12
_lcd12_1:
	MOVLW	0x01
	GOTO	_end_lcd12
_lcd12_off:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.2
    SKPC
    MOVLW	.3
    SUBWF   SRespHH, w      
	BC	_lcd12_
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.1
    SKPC
    MOVLW	.2
    SUBWF   SRespHH, w      
	BNC	    _lcd12_
	MOVLW	0x02
	GOTO	_end_lcd12
_lcd12_:
	MOVLW	' '
_end_lcd12:
	CALL	SendCHAR
;--------------------
;----  13 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	0xFF
    SUBWF   TRespL, f
    MOVLW	.2
    SKPC
    MOVLW	.3
    SUBWF   TRespH, f      
	BC		_lcd13_on
	GOTO	_lcd13_off
_lcd13_on:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.3
    SKPC
    MOVLW	.4
    SUBWF   SRespHH, w      
	BC		_lcd13_1
	MOVLW	0x03
	GOTO	_end_lcd13
_lcd13_1:
	MOVLW	0x01
	GOTO	_end_lcd13
_lcd13_off:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.3
    SKPC
    MOVLW	.4
    SUBWF   SRespHH, w      
	BC	_lcd13_
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.2
    SKPC
    MOVLW	.3
    SUBWF   SRespHH, w      
	BNC	    _lcd13_
	MOVLW	0x02
	GOTO	_end_lcd13
_lcd13_:
	MOVLW	' '
_end_lcd13:
	CALL	SendCHAR
;--------------------
;----  14 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	0xFF
    SUBWF   TRespL, f
    MOVLW	.3
    SKPC
    MOVLW	.4
    SUBWF   TRespH, f      
	BC		_lcd14_on
	GOTO	_lcd14_off
_lcd14_on:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.5
    SKPC
    MOVLW	.6
    SUBWF   SRespHH, w      
	BC		_lcd14_1
	MOVLW	0x03
	GOTO	_end_lcd14
_lcd14_1:
	MOVLW	0x01
	GOTO	_end_lcd14
_lcd14_off:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.5
    SKPC
    MOVLW	.6
    SUBWF   SRespHH, w      
	BC	_lcd14_
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.3
    SKPC
    MOVLW	.4
    SUBWF   SRespHH, w      
	BNC	    _lcd14_
	MOVLW	0x02
	GOTO	_end_lcd14
_lcd14_:
	MOVLW	' '
_end_lcd14:
	CALL	SendCHAR
;--------------------
;----  15 ----
	MOVFW	RespH
	MOVWF	TRespH
	MOVFW	RespL
	MOVWF	TRespL
    MOVLW	0xFF
    SUBWF   TRespL, f
    MOVLW	0x05
    SKPC
    MOVLW	0x06
    SUBWF   TRespH, f      
	BC		_lcd15_on
	GOTO	_lcd15_off
_lcd15_on:
	MOVLW	0x03				;  " "
	GOTO	_end_lcd15
_lcd15_off:
    MOVLW	0xFF
    SUBWF   SRespHL, w
    MOVLW	.5
    SKPC
    MOVLW	.6
    SUBWF   SRespHH, w      
	BNC	    _lcd15_
	MOVLW	0x02
	GOTO	_end_lcd15
_lcd15_:
	MOVLW	' '
_end_lcd15:
	CALL	SendCHAR
;--------------------

;--    --
    MOVLW   LINE2+.11           
    CALL    SendINS        

	MOVFW	Upow
	MOVWF	BUFFER
	CALL	BINToBCD
	MOVFW	huns
	CALL    SendCHAR
	MOVFW	tens
	CALL    SendCHAR
	MOVLW	','
	CALL    SendCHAR
	MOVFW	ones
	CALL    SendCHAR
	MOVLW	'V'
	CALL    SendCHAR
;------------------------------------

;-----     0-2   
    MOVLW   LINE2           
    CALL    SendINS        

	MOVLW	'P'
	CALL    SendCHAR
	MOVF	Barrier, w
	MOVWF	BUFFER

	CALL	BINToBCD

	MOVFW	tens
	CALL    SendCHAR
	MOVFW	ones
	CALL    SendCHAR

	MOVLW	' '
	CALL    SendCHAR

;-----     4-5    -----
	MOVLW	'V'
	CALL    SendCHAR
	MOVF	Volume, w
	MOVWF	BUFFER

	CALL	BINToBCD

	MOVFW	ones
	CALL    SendCHAR

;-----     9  2-  -----
    MOVLW   LINE2+.9				
    CALL    SendINS        
	BTFSS	PORTA, 2
	GOTO	l_off
	MOVLW	'L'
	CALL    SendCHAR
	GOTO	end_l		
l_off:
	MOVLW	' '
	CALL    SendCHAR
end_l:

	CALL	Delay80ms
	GOTO    loop            

pow_low:
    BCF     INTCON, PEIE    	;    
    BCF     INTCON, GIE     	;               

	MOVLW	CLR_DISP			; Clear the Display RAM
	CALL	SendINS
	CALL	Delay5ms			; Wait 5 msecs (Note, Can take up to 4.1 msecs)
	MOVLW	ENTRY_INC			;  increment cursor
	CALL	SendINS
	MOVLW	0x00C				;  display on cursor off
	CALL	SendINS
	MOVLW	LINE1				; 
	CALL	SendINS
  	MOVLW   LINE1+2        		;   3-      
   	CALL    SendINS        
	MOVLW	'B'
	CALL	SendCHAR
	MOVLW	'a'
	CALL	SendCHAR
	MOVLW	't'
	CALL	SendCHAR
	MOVLW	't'
	CALL	SendCHAR
	MOVLW	'e'
	CALL	SendCHAR
	MOVLW	'r'
	CALL	SendCHAR
	MOVLW	'y'
	CALL	SendCHAR
	MOVLW	' '
	CALL	SendCHAR
	MOVLW	'l'
	CALL	SendCHAR
	MOVLW	'o'
	CALL	SendCHAR
	MOVLW	'w'
	CALL	SendCHAR
	MOVLW	','
	CALL	SendCHAR
  	MOVLW   LINE2+4        		;   5-      
   	CALL    SendINS        
	MOVLW	's'
	CALL	SendCHAR
	MOVLW	'h'
	CALL	SendCHAR
	MOVLW	'u'
	CALL	SendCHAR
	MOVLW	't'
	CALL	SendCHAR
	MOVLW	'd'
	CALL	SendCHAR
	MOVLW	'o'
	CALL	SendCHAR
	MOVLW	'w'
	CALL	SendCHAR
	MOVLW	'n'
	CALL	SendCHAR

	MOVLW	.3
	MOVWF	Cnt
ss_loop:
	BSF		STATUS, RP0			;    1
	MOVLW	0x46
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0	
	MOVLW	0x23
	MOVWF	CCPR2L				;     
	BSF		T2CON, TMR2ON
	CALL	Delay80ms			
	BCF		T2CON, TMR2ON

	CALL	Delay80ms			
	BSF		STATUS, RP0			;    1
	MOVLW	0xBA
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0	
	MOVLW	0x5D
	MOVWF	CCPR2L				;     
	BSF		T2CON, TMR2ON
	CALL	Delay80ms			
	BCF		T2CON, TMR2ON

	CALL	Delay80ms			
	BSF		STATUS, RP0			;    1
	MOVLW	0xFF
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0	
	MOVLW	0x7F
	MOVWF	CCPR2L				;     
	BSF		T2CON, TMR2ON
	CALL	Delay80ms			
	CALL	Delay80ms			
	BCF		T2CON, TMR2ON

	CLRF	CCP2CON				;      "0"

	CALL	Delay80ms			
	CALL	Delay80ms			
	CALL	Delay80ms			
	CALL	Delay80ms			
	CALL	Delay80ms			
	CALL	Delay80ms			

	DECF	Cnt, f
	BNZ		ss_loop
	
	SLEEP


;*************************************************************************
;* The LCD Module Subroutines                                            *
;*************************************************************************

;*************************************************************************;
;                 Initialize the LCD                                      ;
;*************************************************************************;
InitLCD:
	CALL	Delay40ms			; Wait 40 msecs before Reset 
	BCF		RS					; send an 8 bit instruction
	MOVLW	0x03				; Reset Command
	CALL	NybbleOut			; Send the Nybble
    CALL	Delay5ms			; Wait 5 msecs before Sending Again
	MOVLW	0x02				;  Set 4 Bit Mode  !!!
	CALL	NybbleOut              
	;---   250 uS ---
	MOVLW	0xD0				 
	MOVWF	DCnt  
DLoopIL:
	DECFSZ	DCnt, f
	GOTO	DLoopIL
	;--------------------------
	MOVLW	0x028				; 4 bit, 2 Line, 5x7 font
	CALL	SendINS
	MOVLW	0x010				; display shift off
	CALL	SendINS
	MOVLW	CLR_DISP			; Clear the Display RAM
	CALL	SendINS
	CALL	Delay5ms			; Wait 5 msecs (Note, Can take up to 4.1 msecs)
	MOVLW	ENTRY_INC			;  increment cursor
	CALL	SendINS
	MOVLW	0x00C				;  display on cursor off
	CALL	SendINS
	MOVLW	CGRAM
	CALL	SendINS
;------------- #1 ------------------
	MOVLW	0x00
	CALL	SendCHAR
	MOVLW	0x00
	CALL	SendCHAR
	MOVLW	0x1F
	CALL	SendCHAR
	MOVLW	0x1F
	CALL	SendCHAR
	MOVLW	0x1F
	CALL	SendCHAR
	MOVLW	0x1F
	CALL	SendCHAR
	MOVLW	0x00
	CALL	SendCHAR
	MOVLW	0x00
	CALL	SendCHAR
;----------------------------------
;------------- #2 ------------------
	MOVLW	0x00
	CALL	SendCHAR
	MOVLW	0x01
	CALL	SendCHAR
	MOVLW	0x01
	CALL	SendCHAR
	MOVLW	0x01
	CALL	SendCHAR
	MOVLW	0x01
	CALL	SendCHAR
	MOVLW	0x01
	CALL	SendCHAR
	MOVLW	0x01
	CALL	SendCHAR
	MOVLW	0x00
	CALL	SendCHAR
;----------------------------------
;------------- #3 ------------------
	MOVLW	0x00
	CALL	SendCHAR
	MOVLW	0x01
	CALL	SendCHAR
	MOVLW	0x1F
	CALL	SendCHAR
	MOVLW	0x1F
	CALL	SendCHAR
	MOVLW	0x1F
	CALL	SendCHAR
	MOVLW	0x1F
	CALL	SendCHAR
	MOVLW	0x01
	CALL	SendCHAR
	MOVLW	0x00
	CALL	SendCHAR
;----------------------------------
	MOVLW	LINE1				; 
	CALL	SendINS
	RETURN


;*************************************************************************;
;              Send an instruction in W out to the LCD                    ;
;*************************************************************************;
SendINS:                         
	MOVWF	Temp				; Save the Temporary Value
	SWAPF	Temp, w				; Send the High Nybble
	BCF		RS					;  
	CALL	NybbleOut
	MOVFW	Temp				; Send the Low Nybble
	CALL	NybbleOut
	RETURN

;*************************************************************************;
;              Send the character in W out to the LCD                     ;
;*************************************************************************;
SendASCII:						; Send nbr as ASCII character
	ADDLW	'0'
SendCHAR:						; Send the Character to the LCD
	MOVWF	Temp				; Save the Temporary Value
	SWAPF	Temp, w				; Send the High Nybble
	BSF		RS					;  
	CALL	NybbleOut
	MOVFW	Temp				; Send the Low Nybble
	BSF		RS					;  
	CALL	NybbleOut
	RETURN

;*************************************************************************;
;              Send the nibble in W out to the LCD                        ;
;*************************************************************************;
NybbleOut:                      ; Send a Nybble to the LCD
    ANDLW   0x0F            	;   
    MOVWF   TEMP	           	;       TEMP1
	MOVFW	LCD_DATA			;      LCD
    ANDLW   0xF0     			;  ,    LCD
    IORWF   TEMP, w	        	;   
    MOVWF   LCD_DATA           	;       LCD
	EStrobe						; Strobe out the LCD Data
	MOVLW	0xD0				;   250 uS
	MOVWF	DCnt  
DLoop1:
	DECFSZ	DCnt, f
	GOTO	DLoop1
	RETURN

;**************************************************************************
;       5, 40, 80 
;**************************************************************************
Delay80ms:
	MOVLW	0xFF				;     (256)
	GOTO	$+4 
Delay40ms:
	MOVLW	0x85				;     (133) 
	GOTO	$+2					;    
Delay5ms:
	MOVLW   0x10				;    ...
	MOVWF   DCnt2				; ...  (16)
DLoopOut:	
	MOVLW   0xFF            	;    ...
	MOVWF   DCnt          		; ...  (256)
DLoopIn:						;    ~0,3 mS
	DECFSZ  DCnt, f       		;   
	GOTO    DLoopIn	        	;  DCnt  0,  
	DECFSZ  DCnt2, f			;     
	GOTO    DLoopOut          	;  DCnt2  0,  
	RETURN
	
;**************************************************************************

;***************************************************************
;        USART     MCP3201
;        1.25 ,    
;***************************************************************
INIT_USART:
    BSF     STATUS, RP0     	; Select Register page 1
    BCF     TXSTA, BRGH     	;  BRGH -   , 
	MOVLW   DevFreq/(4*ADCFreq)	; Baud Rate = DevFreq/(4(X+1)) (   )
    MOVWF   SPBRG           	;    
    BSF     TXSTA, SYNC     	;  
    BSF     TXSTA, CSRC     	;  
    BCF     STATUS, RP0     	; Select Register page 0
    BSF     RCSTA, SPEN     	;  USART
    BCF     RCSTA, SREN     	;   
    BCF     RCSTA, CREN     	;   
    BSF     STATUS, RP0     	; Select Register page 1
    BCF     PIE1, RCIE      	;     
    BCF     STATUS, RP0     	; Select Register page 0
    BCF     RCSTA, RX9      	;   9- 
    RETURN

;****************************************************************
;         ,   USART
;****************************************************************
ADC_WORK:
	BCF     ADC_CS				;  ADC
	BSF     RCSTA, CREN			;    
adcloop:
	BTFSS   RCSTA, OERR			;      (,  1)
	GOTO    adcloop
	BSF     ADC_CS				;  ADC
	BCF     RCSTA, CREN			;    
	RETURN

;********************************************************************	
;	 CCP1   .   5 
;********************************************************************	
InitCCP1:        
	CLRF    TMR1H           	;    TMR1
	CLRF    TMR1L
	MOVLW   b'00110000'     	;   1:8 (3.2 uS),   ,
	MOVWF   T1CON           	;   1/4 OSC,   
	MOVLW	0x06				;   061A'h   CCPR1H:CCPR1L  
	MOVWF	CCPR1H				;    200 
	MOVLW	0x1A
	MOVWF	CCPR1L
	MOVLW   b'00001011'     	;  ,   RC2  ,
	MOVWF   CCP1CON         	;  CCP1IF,  TMR1H:TMR1L
	BSF		STATUS, RP0			;    1
    CLRF    PIE1            	;      
    CLRF    PIE2
    BSF     PIE1, CCP1IE    	;     CCP1
	BCF		STATUS, RP0			;    0
    BSF     INTCON, PEIE    	;    
    BSF     INTCON, GIE     	;               
    BSF     T1CON, TMR1ON   	;  
	RETURN
;********************************************************************

;**************************************************************	
;	 CCP2   .  
;**************************************************************	
InitCCP2
	CLRF	TMR2
	BSF		T2CON, T2CKPS1		;    TMR2  1:16
	BSF		STATUS, RP0			;    1
	MOVLW	0xFF
	MOVWF	PR2					;       
	BCF		STATUS, RP0			;    0
	MOVLW	0x1F
	MOVWF	CCPR2L				;      = 5
	MOVLW	0x0C			
	MOVWF	CCP2CON				;   CCP2/PWM2   . 
	RETURN
;**************************************************************

;**************************************************************	
;	  
;**************************************************************	
InitADC:
    BSF     STATUS, RP0     	; Select Bank 1
    MOVLW   b'01001110'     	;  , T=16*Tosc, 
    MOVWF   ADCON1          	;    AN0,   - Vss  Vdd
    BCF     STATUS, RP0     	; Select Bank 0
    MOVLW   b'01000001'     	; T=16*Tosc,   - AN0,   ,
    MOVWF   ADCON0          	;  .
	RETURN


;***************************************************************
; Routine: reverse8bit
;  
; Input X  = abcdefgh , Output X = hgfedcba
; Written by Dmitry A. Kiryashov 2000
; 12 clocks/words
; (!)  BUFINT     
;***************************************************************
reverse8bit:
	SWAPF	BUFINT, w			;efghabcd
	XORWF	BUFINT, w			;efghabcd
								;abcdefgh
	ANDLW	0x66				;.fg..bc.
								;.bc..fg.
	XORWF	BUFINT, f			;afgdebch
	RRF		BUFINT, w
	RRF		BUFINT, f			;hafgdebc
	ANDLW	0x55				;.a.g.e.c
	ADDWF	BUFINT, f			;h.f.d.b.
								;a.g.e.c.
	RRF		BUFINT, f			;.h.f.d.b
								;.a.g.e.c
	ADDWF	BUFINT, f			;ahgfedcb
	RLF		BUFINT, w
	RLF		BUFINT, w			;   
    RETURN
;***************************************************************

;*******************************************************************
; Routine: BINToBCD
;    3  
;   - BUFFER
;   - huns, tens, ones
;*******************************************************************
BINToBCD:
	MOVLW	.8
	MOVWF	Cnt
	CLRF	huns
	CLRF	tens
	CLRF	ones

BCDADD3:
	MOVLW	.5
	SUBWF	huns, 0
	BTFSC	STATUS, C
	CALL	ADD3HUNS

	MOVLW	.5
	SUBWF	tens, 0
	BTFSC	STATUS, C
	CALL	ADD3TENS	

	MOVLW	.5
	SUBWF	ones, 0
	BTFSC	STATUS, C
	CALL	ADD3ONES
	
	DECF	Cnt, 1
	CLRC
	RLF		BUFFER, 1
	RLF		ones, 1
	BTFSC	ones, 4
	CALL	CARRYONES
	RLF		tens, 1

	BTFSC	tens, 4
	CALL	CARRYTENS
	RLF		huns, 1
	CLRC

	MOVFW	Cnt
	SKPZ
	GOTO	BCDADD3

	MOVFW	huns
	ADDLW	0x30
	MOVWF	huns

	MOVFW	tens
	ADDLW	0x30
	MOVWF	tens
	
	MOVFW	ones
	ADDLW	0x30
	MOVWF	ones	

	RETURN

ADD3HUNS:
	MOVLW	.3
	ADDWF	huns, f
	RETURN	

ADD3TENS:
	MOVLW	.3
	ADDWF	tens, f
	RETURN

ADD3ONES:
	MOVLW	.3
	ADDWF	ones, f
	RETURN

CARRYONES:
	BCF		ones, 4
	SETC
	RETURN

CARRYTENS:
	BCF		tens, 4
	SETC
	RETURN


;************************************************************************
;  16   16 
; Input:
;  x, x+1 - 16 bit unsigned integer dividend (x - lsb, x+1 - msb)
;  y, y+1 - 16 bit unsigned integer divisor
; Output:
;  x, x+1 - 16 bit unsigned integer quotient
; Temporary:
;  counter
;  x+2, x+3 - 16 bit remainder
;  temp - remainder extension
; Size: 36 instructions
; Max timing: 6+16*(5+13+3)-1+2+2=345 cycles
;   -   !!!
;************************************************************************
div16by16:
	CLRF	x+2        ;clear
	CLRF	x+3        ;remainder
div16by16loopinit:
	CLRF	Temp       ;clear remainder extension
	MOVLW	.16
	MOVWF	Cnt
	SETC            ;first iteration will be subtraction
div16by16loop:
;--- shift in next result bit and shift out next dividend bit to remainder ---
	RLF		x, f        ;shift lsb
	RLF		x+1, f      ;shift msb
	RLF		x+2, f
	RLF		x+3, f
	RLF		Temp, f

	MOVFW	y
	BTFSS	x, 0
	GOTO	div16by16add
;-----------------------------------------------------------------------------

;--- subtract divisor from remainder ---
	SUBWF	x+2, f
	MOVFW	y+1
	SKPC
	INCFSZ	y+1, w
	SUBWF	x+3, f
	MOVLW	.1
	SKPC
	SUBWF	Temp, f
	GOTO div16by16next

;--- add divisor to remainder ---
div16by16add:
	ADDWF	x+2, f
	MOVFW	y+1
	SKPNC
	INCFSZ	y+1, w
	ADDWF	x+3, f
	MOVLW	.1
	SKPNC
	ADDWF	Temp, f

;--- carry is next result bit ---
div16by16next:
	DECFSZ	Cnt, f
	GOTO	div16by16loop

;--- shift in last bit ---
	RLF		x, f
	RLF		x+1, f
	RETURN
;************************************************************************


	END                       ; directive 'end of program'

